{% set title = 'Bilan sysma_action' %}
{% extends 'report/reportLayout.twig' %}

{% block content %}
    <h1>Bilan actions</h1>
    <p>Maintenir la touche Control pour sélectionner plusieurs choix dans les listes déroulantes.</p>

    <form id="theform" method='post' action='#res' novalidate>

        {% form_theme form 'bootstrap_3_layout.html.twig' %}
        {{ form_widget(form) }}


        <button class="btn btn-primary" onclick="$('#theform').attr('action', '?#res');
                                         $('#theform').submit()">Afficher le bilan</button>
        <button class="btn btn-default" onclick="$('#theform').attr('action', '?csv#res');
                                        $('#theform').submit()">Générer un fichier CSV</button>

    </form>


    <a name='res'></a>
    {% if tabT|length == 0 %}
        <h2>{{ tabT|length }}
            objet</h2>
    {% endif %}
    {% if tabT|length > 0 and tabT[0].sysmaObjectsArray|length > 0 %}

        {% set nbRes = 0 %}
        {% set totalPerimetre = 0 %}
        {% set totalSurface = 0 %}

        {% for T in tabT %}
            {% set nbRes = nbRes + T.sysmaObjectsArray|length %}
        {% endfor %}
        <h2 id="resCount">{{ nbRes }}
            résultats,
            {{ tabT|length }}
            {{ tabT|length > 1 ? 'fiches' : 'fiche' }}
            actions</h2>

        <div id="actions" class="">

            <input class="search" placeholder="Rechercher..." id="search"/>

            <table class="table table-condensed table-striped table-hover table-sm" id="resTable">

                <thead class="thead-dark">
                    <tr>
                        <th>Index Action - Objet</th>
                        <th>Id Action</th>
                        <th>Fiche</th>
                        <th>Action</th>
                        <th>Type d'action</th>
                        <th>Organisation</th>
                        <th>Date début</th>
                        <th>Date fin</th>
                        <th>Date engagement</th>

                        {%  if COST_MANAGEMENT != 'desactivated' %}
                            <th>Type coût</th>
                        {%  endif  %}
                        {%  if COST_MANAGEMENT != 'desactivated' %}
                            <th>Coût prév.
                                {{ HT_TTC }}</th>
                        {%  endif  %}
                        {%  if COST_MANAGEMENT != 'desactivated' %}
                            <th>Coût final
                                {{ HT_TTC }}</th>
                        {%  endif  %}

                        <th>Date modif.</th>
                        <th>Statut</th>
                        <th>Contrats</th>
                        <th>Type d'objet</th>
                        {% if regroup != 1 %}
                            <th>Id Objet</th>
                            <th>Objet</th>

                        {% endif %}
                        {% if infogeo == 1 %}
                            <th>Lin./périm. (m)</th>
                        {% endif %}
                        {% if infogeo == 1 %}
                            <th>Surface (m²)</th>
                        {% endif %}
                        {% if tabC[tabT[0].sysmaObjectsArray[0].id] is defined %}
                            <th>Communes</th>
                        {% endif %}
                        {% if tabEPCI[tabT[0].sysmaObjectsArray[0].id] is defined %}
                            <th>EPCI</th>
                        {% endif %}
                        {% if tabME[tabT[0].sysmaObjectsArray[0].id] is defined %}
                            <th>ME</th>
                            <th>ME_id</th>
                        {% endif %}
                        {% if regroup != 1 %}
                            <th>Date début</th>
                            <th>Date fin</th>
                            <th>Statut</th>

                            {% if tabT[0].data is defined %}
                                {% for V in tabT[0].data %}
                                    <th>{{V.parameter.parameter|raw }}</th>
                                {% endfor %}
                            {% endif %}
                            {# donnes des objets : Expérimental #}
                            {% if tabT[0].sysmaObjectsArray[0].data is defined %}
                                {% for V in tabT[0].sysmaObjectsArray[0].data  %}
                                    <th>[Obj]
                                        {{V.parameter.parameter|raw }}</th>
                                {% endfor %}
                            {% endif %}
                        {% endif %}
                        {% if regroup == 1 %}
                            <th>Nombre d'objets</th>
                            <th>Liste objets</th>
                        {% endif %}

                    </tr>
                </thead>

                <tbody class="list">

                    {% for T in tabT %}
                        {% if T.id != null %}

                            {% set index0 = loop.index %}


                            {% if regroup != 1 %}
                                {# non regroup par fiche sysma_action #}


                                {% for O in T.sysmaObjectsArray|default(null) %}

                                    <tr>
                                        <td>{{ index0 ~'-' ~ loop.index   }}</td>
                                        <td class="sysma_action_id">{{ T.id }}</td>
                                        <td>
                                            <a href="{{ url('report-work', { ids : T.id } ) }}" target="_blank">Fiche synth.</a>
                                        </td>
                                        <td class="sysma_action">{{ T.sysma_action|raw }}</td>
                                        <td class="sysma_action_type">{#{{ O.sysma_object_type|raw }}<br>#}{{ T.sysma_action_type|raw }}</td>
                                        <td class="action_organisation">{{ T.organisation|raw }}</td>

                                        <td class="action_start_date">{{ T.start_date==0 ? null : T.start_date }}</td>
                                        <td class="action_end_date">{{ T.end_date==0 ? null : T.end_date }}</td>
                                        <td class="action_program_year">{{ T.program_year==0 ? null : T.program_year }}</td>
                                        {%  if COST_MANAGEMENT != 'desactivated' %}
                                            <td>{{  T.unit_measure_estimated_user }}
                                            </td>
                                        {%  endif  %}
                                        {%  if COST_MANAGEMENT != 'desactivated' %}
                                            <td>{{  T.total_cost_estimated_user }}€</td>
                                        {%  endif  %}
                                        {%  if COST_MANAGEMENT != 'desactivated' %}
                                            <td>{{  T.total_cost_final_user }}€
                                            </td>
                                        {%  endif  %}
                                        <td>{{ T.modified_at == null ? null : T.modified_at|date('d/m/Y') }}</td>
                                        <td class="action_status">
                                            {{ include('sysma-action/sysmaActionStatusLabel.twig') }}</td>
                                        <td class="contracts_labels">
                                            {{ T.contracts_labels|raw }}</td>
                                        <td class="sysma_object_type">{{ O.sysma_object_type|raw }}</td>
                                        <td class="sysma_object_id">
                                            <a href="{{ url('objet-carte',{ 'sysma_object_id' : O.id }) }}" target="_blank">{{ O.id }}</a>
                                        </td>
                                        <td class="sysma_object">{{ O.sysma_object|raw }}</td>

                                        {% if infogeo == 1 %}
                                            <td class="perimetre">
                                                {% if tabLin[O.id] is defined %}
                                                    {{tabLin[O.id]|round()}}
                                                    {% set totalPerimetre = totalPerimetre + tabLin[O.id] %}
                                                {% endif %}
                                            </td>
                                        {% endif %}
                                        {% if infogeo == 1 %}
                                            <td class="surface">

                                                {% if tabSurf[O.id] is defined %}
                                                    {{tabSurf[O.id]|round()}}
                                                    {% set totalSurface = totalSurface + tabSurf[O.id]%}
                                                {% endif %}
                                            </td>
                                        {% endif %}

                                        {% if tabC[O.id] is defined %}
                                            <td>
                                                {% for c in tabC[O.id] %}
                                                    {{ c.sysma_object }}
                                                {% endfor %}
                                            </td>
                                        {% endif %}

                                        {% if tabEPCI[O.id] is defined %}
                                            <td>
                                                {% for c in tabEPCI[O.id] %}
                                                    {{ c.sysma_object }}
                                                {% endfor %}
                                            </td>
                                        {% endif %}

                                        {% if tabME[O.id] is defined %}
                                            <td>
                                                {% for c in tabME[O.id] %}
                                                    {{ c.sysma_object }}
                                                {% endfor %}
                                            </td>
                                            <td>
                                                {% for c in tabME[O.id] %}
                                                    {{ c.sysma_object_id }}
                                                {% endfor %}
                                            </td>
                                        {% endif %}
                                        <td>{{ O.start_date==0 ? null : O.start_date|date('d/m/Y') }}</td>
                                        <td>{{ O.end_date==0 ? null : O.end_date|date('d/m/Y') }}</td>
                                        <td>
                                            {{ include('sysma-object/sysmaObjectStatusLabel.twig') }}</td>
                                        {% if tabT[0].data is defined %}
                                            {% for V in T.data %}
                                                <td>
                                                    {{V.value|join(',')|raw }}
                                                </td>
                                            {% endfor %}
                                        {% endif %}
                                        {# # donnees des objets : Expérimental  #}
                                        {% if tabT[0].sysmaObjectsArray[0].data is defined %}
                                            {% for V in T.sysmaObjectsArray[0].data  %}
                                                <td>{{V.value|join(',')|raw }}</td>
                                            {% endfor %}
                                        {% endif %}


                                    </tr>
                                {% endfor %}

                            {% else %}
                                {# regroup par fiche sysma_action #}

                                {% set lin = 0 %}
                                {% set surf = 0 %}
                                {% set communes = null %}
                                {% set bvct = null %}
                                {% set listeME = {} %}
                                {%  set tabTypeObjet = {} %}


                                {% for O in T.sysmaObjectsArray|default(null) %}


                                    {% if tabLin|length > 0  %}
                                        {% if tabLin[O.id] is defined %}
                                            {% set lin = lin + tabLin[O.id]|round() %}
                                        {% endif %}
                                    {% endif %}

                                    {% if tabSurf|length > 0 %}
                                        {% if tabSurf[O.id] is defined %}
                                            {% set surf = surf + tabSurf[O.id]|round() %}
                                        {% endif %}
                                    {% endif %}

                                    {% if tabC[O.id] is defined %}
                                        {% for c in tabC[O.id] %}
                                            {% set communes = communes~', '~c.sysma_object %}
                                        {% endfor %}
                                    {% endif %}


                                    {% if tabBVCT[O.id] is defined %}
                                        {% for c in tabBVCT[O.id] %}
                                            {% set bvct = bvct~', '~c.sysma_object %}
                                        {% endfor %}
                                    {% endif %}


                                    {% if tabME[O.id] is defined %}
                                        {% for c in tabME[O.id] %}
                                            {% set index = c.sysma_object %}
                                            {% set listeME = listeME|merge({(index):1}) %}
                                        {% endfor %}
                                    {% endif %}


                                    {%  set tabTypeObjet = {(T.id) : O.sysma_object_type} %}


                                {% endfor %}


                                <tr>
                                    <td>{{ T.id }}</td>
                                    <td>
                                        <a href="{{ url('report-work', { ids : T.id } ) }}" target="_blank">Fiche synth.</a>
                                    </td>
                                    <td>{{ T.sysma_action|raw }}</td>
                                    <td>{#{{ tabTypeObjet[T.id]|raw}}<br>#}{{ T.sysma_action_type|raw }}</td>
                                    <td>{{ T.organisation|raw }}</td>

                                    <td>{{ T.start_date==0 ? null : T.start_date }}</td>
                                    <td>{{ T.end_date==0 ? null : T.end_date }}</td>
                                    <td>{{ T.program_year==0 ? null : T.program_year }}</td>

                                    {%  if COST_MANAGEMENT != 'desactivated' %}
                                        <td>>{{  T.unit_measure_estimated_user }}</td>
                                    {%  endif  %}
                                    {%  if COST_MANAGEMENT != 'desactivated' %}
                                        <td class="costEstimatedUser">{{  T.total_cost_estimated_user }}</td>
                                    {%  endif  %}
                                    {%  if COST_MANAGEMENT != 'desactivated' %}
                                        <td class="costFinalUser">{{  T.total_cost_final_user }}</td>
                                    {%  endif  %}
                                    <td>{{ T.modified_at == null ? null : T.modified_at|date('d/m/Y') }}</td>
                                    <td>{{ include('sysma-action/sysmaActionStatusLabel.twig') }}</td>
                                    <td class="contract">{{ T.contracts_labels|raw }}</td>
                                    <td class="sysma_object_type">
                                        {% if T.sysmaObjectsArray|length >= 1 %}
                                            {{ T.sysmaObjectsArray.0.sysma_object_type|raw }}
                                        {% endif %}
                                    </td>
                                    {% if infogeo == 1 %}
                                        <td class="perimetre">
                                            {{ lin }}
                                        </td>
                                        <td class="surface">
                                            {{ surf }}
                                        </td>
                                    {% endif %}

                                    {% if T.sysmaObjectsArray|length >= 1 and  tabC[T.sysmaObjectsArray.0.id] is defined %}
                                        <td class="commune">
                                            {{ communes|slice(2) }}
                                        </td>
                                    {% endif %}
                                    {% if T.sysmaObjectsArray|length >= 1 and tabBVCT[T.sysmaObjectsArray.0.id] is defined %}
                                        <td class="bvct">
                                            {{ bvct|slice(2) }}
                                        </td>
                                    {% endif %}
                                    {% if T.sysmaObjectsArray|length >= 1 and tabME[T.sysmaObjectsArray.0.id] is defined %}
                                        <td class="me">
                                            {% for me in listeME|keys %}
                                                {{  me }}
                                            {%  endfor %}
                                        </td>
                                    {% endif %}
                                    <td>

                                        {% if T.sysmaObjectsArray|length>0%}
                                            {{ T.sysmaObjectsArray.0.sysma_object_type|raw }}
                                            :
                                            {{ T.sysmaObjectsArray|length }}
                                        {%  endif %}

                                    </td>
                                    <td>
                                        {%  for O in T.sysmaObjectsArray %}
                                            <a href="{{ url('objet-carte', { 'sysma_object_id' : O.id }) }}" target="_blank">{{  O.id }}
                                            </a>
                                        {%  endfor %}
                                    </td>


                                </tr>


                            {% endif %}

                        {% endif %}
                    {% endfor %}                  

                </tbody>

                <tfoot class="">
                    <tr>
                        <th>Index Action - Objet</th>
                        <th>Id Action</th>
                        <th>Fiche</th>
                        <th>Action</th>
                        <th>Type d'action</th>
                        <th>Organisation</th>
                        <th>Date début</th>
                        <th>Date fin</th>
                        <th>Date engagement</th>

                        {%  if COST_MANAGEMENT != 'desactivated' %}
                            <th>Type coût</th>
                        {%  endif  %}
                        {%  if COST_MANAGEMENT != 'desactivated' %}
                            <th><span id="totalCostEstimatedUser">{{ tabCost.total_cost_estimated_user }}</span> €
                                {{ HT_TTC }}</th>
                        {%  endif  %}
                        {%  if COST_MANAGEMENT != 'desactivated' %}
                            <th><span id="totalCostFinalUser">{{ tabCost.total_cost_final_user }}</span> €
                                {{ HT_TTC }}</th>
                        {%  endif  %}

                        <th>Date modif.</th>
                        <th>Statut</th>
                        <th>Contrats</th>
                        <th>Type d'objet</th>
                        {% if regroup != 1 %}
                            <th>Id Objet</th>
                            <th>Objet</th>

                        {% endif %}
                        {% if infogeo == 1 %}
                            <th><span id="totalPerimetre">{{ totalPerimetre|round }}</span> m</th>
                        {% endif %}
                        {% if infogeo == 1 %}
                            <th><span id="totalSurface">{{ totalSurface|round }}</span> m²</th>
                        {% endif %}
                        {% if tabC[tabT[0].sysmaObjectsArray[0].id] is defined %}
                            <th>Communes</th>
                        {% endif %}
                        {% if tabEPCI[tabT[0].sysmaObjectsArray[0].id] is defined %}
                            <th>EPCI</th>
                        {% endif %}
                        {% if tabME[tabT[0].sysmaObjectsArray[0].id] is defined %}
                            <th>ME</th>
                            <th>ME_id</th>
                        {% endif %}
                        {% if regroup != 1 %}
                            <th>Date début</th>
                            <th>Date fin</th>
                            <th>Statut</th>

                            {% if tabT[0].data is defined %}
                                {% for V in tabT[0].data %}
                                    <th>{{V.parameter.parameter|raw }}</th>
                                {% endfor %}
                            {% endif %}
                            {# donnes des objets : Expérimental #}
                            {% if tabT[0].sysmaObjectsArray[0].data is defined %}
                                {% for V in tabT[0].sysmaObjectsArray[0].data  %}
                                    <th>[Obj]
                                        {{V.parameter.parameter|raw }}</th>
                                {% endfor %}
                            {% endif %}
                        {% endif %}
                        {% if regroup == 1 %}
                            <th>Nombre d'objets</th>
                            <th>Liste objets</th>
                        {% endif %}

                    </tr>
                </tfoot>

            </table>

        </div>


    {% endif %}


    <script src="/js/list.min.js"></script>
    <script>
        var options = {
            valueNames: [
                'sysma_action_id',
                'sysma_action',
                'sysma_action_type',
                'action_organisation',
                'action_start_date',
                'action_end_date',
                'action_program_year',
                'action_status',
                'contracts_labels',
                'sysma_object_type',
                'sysma_object_id',
                'sysma_object'
            ]
        };

        var actionList = new List('actions', options);


        let searchInput = document.getElementById('search');
        var totalPerimetre = document.getElementById('totalPerimetre')
        var totalSurface = document.getElementById('totalSurface')
        var totalCostEstimatedUser = document.getElementById('totalCostEstimatedUser')
        var totalCostFinalUser = document.getElementById('totalCostFinalUser')

        searchInput.addEventListener("keyup", function () {
            document.getElementById('resCount').innerHTML = document.getElementById('resTable').rows.length - 2 + ' résultat(s)';
 {% if infogeo == 1 %}
            let perimetres = document.getElementsByClassName('perimetre');
            var totalP = 0;
            Array.prototype.forEach.call(perimetres, function (el) {
                totalP += Number(el.textContent);               
            });
            totalPerimetre.textContent = totalP;

            let surfaces = document.getElementsByClassName('surface');
            var totalS = 0;
            Array.prototype.forEach.call(surfaces, function (el) {
                totalS += Number(el.textContent);              
            });
            totalSurface.textContent = totalS;
            {% endif %}
/* NO COST CALCULATION (logique unit / object non reproduite en JS)
            let CEU = document.getElementsByClassName('costEstimatedUser');
            var totalCEU = 0;
            Array.prototype.forEach.call(CEU, function (el) {
                totalCEU += Number(el.textContent);
                console.log(el.textContent);
            });*/
            totalCostEstimatedUser.textContent = '-' ;
/*
            let CFU = document.getElementsByClassName('costFinalUser');
            var totalCFU = 0;
            Array.prototype.forEach.call(CFU, function (el) {
                totalCFU += Number(el.textContent);
                console.log(el.textContent);
            });*/
            totalCostFinalUser.textContent = '-' ;

        });
    </script>


{% endblock %}
